﻿using C1.WPF;
using C1.WPF.DateTimeEditors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DatePickerUpDownKeys
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            datePicker.Loaded += (s, e) =>
            {
                var maskedTextBox = datePicker.Template.FindName("TextBox", datePicker) as C1MaskedTextBox;
                maskedTextBox.PreviewKeyDown += MaskedTextBox_PreviewKeyDown;
            };
        }

        private void MaskedTextBox_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if ((e.Key == Key.Up || e.Key == Key.Down) && datePicker.SelectedDate.HasValue)
            {
                e.Handled = true;
                switch (e.Key)
                {
                    case Key.Up:
                        datePicker.Increment(TimeSpan.FromDays(1));
                        break;

                    case Key.Down:
                        datePicker.Decrement(TimeSpan.FromDays(1));
                        break;
                }
            }
        }
    }

    public static class Extensions
    {
        public static void Increment(this C1DatePicker datePicker, TimeSpan time)
        {
            datePicker.SelectedDate = datePicker.SelectedDate.Value + time;
        }

        public static void Decrement(this C1DatePicker datePicker, TimeSpan time)
        {
            datePicker.SelectedDate = datePicker.SelectedDate.Value - time;
        }
    }
}
